-- This is a modified version of the source from
-- http://lua-users.org/wiki/InheritanceTutorial

local function class(base_class)
    local new_class = {}
    local class_mt = {__index = new_class}

    function new_class:new(o, settings)
        local newinst = o or {}
        setmetatable(newinst, class_mt)
        newinst:init(settings)
        return newinst
    end

    --function new_class:init(settings)
    --end

    if base_class then
        setmetatable(new_class, {__index = base_class})
    end

    -- Return the class object of the instance
    function new_class:class()
        return new_class
    end

    -- Return the superclass object of the instance
    function new_class:super()
        return base_class
    end

    -- Return true if the caller is an instance of class
    function new_class:isa(class)
        local cur_class = new_class
        while cur_class do
            if cur_class == class then
                return true
            end
            cur_class = cur_class:super()
        end
        return false
    end

    function new_class:merge(settings, force)
        for k, v in pairs(settings) do
            if force or not self[k] then
                self[k] = v
            end
        end
    end

    return new_class
end

return class
