local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('linux_types')

ffi.cdef[[
struct timeval {
    __kernel_time_t tv_sec;
    __kernel_suseconds_t tv_usec;
};
struct timezone {
    int tz_minuteswest;
    int tz_dsttime;
};
struct xxx_itimerspec {
    struct timespec it_interval;
    struct timespec it_value;
};
struct itimerval {
    struct timeval it_interval;
    struct timeval it_value;
};
]]

local defs = {
    ITIMER_REAL = '0',
    ITIMER_VIRTUAL = '1',
    ITIMER_PROF = '2',
    CLOCK_REALTIME = '0',
    CLOCK_MONOTONIC = '1',
    CLOCK_PROCESS_CPUTIME_ID = '2',
    CLOCK_THREAD_CPUTIME_ID = '3',
    CLOCK_MONOTONIC_RAW = '4',
    CLOCK_REALTIME_COARSE = '5',
    CLOCK_MONOTONIC_COARSE = '6',
    CLOCK_BOOTTIME = '7',
    CLOCK_REALTIME_ALARM = '8',
    CLOCK_BOOTTIME_ALARM = '9',
    CLOCK_SGI_CYCLE = '10',
    CLOCK_TAI = '11',
    MAX_CLOCKS = '16',
    CLOCKS_MONO = '1',
    TIMER_ABSTIME = '0x01',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

