local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('bits_types')
lj_include('stddef')
lj_include('time')
lj_include('bits_sched')

ffi.cdef[[
int sched_setparam(__pid_t __pid, const struct sched_param *__param);
int sched_getparam(__pid_t __pid, struct sched_param *__param);
int sched_setscheduler(__pid_t __pid, int __policy,
    const struct sched_param *__param);
int sched_getscheduler(__pid_t __pid);
int sched_yield(void);
int sched_get_priority_max(int __algorithm);
int sched_get_priority_min(int __algorithm);
int sched_rr_get_interval(__pid_t __pid, struct timespec *__t);
int sched_setaffinity(__pid_t __pid, size_t __cpusetsize,
    const cpu_set_t * __cpuset);
int sched_getaffinity(__pid_t __pid, size_t __cpusetsize,
    cpu_set_t * __cpuset);
]]

local defs = {
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

