local sqlite3 = require 'lsqlite3'
local log = require 'log'
local cjson = require 'cjson'
local armadb_client = require 'armadb_client'
local config = require 'system_config'

local m = {}

local function get_mx_device_info(mx_dev)
    local client = armadb_client:new({host='127.0.0.1'})
    if not client then return {} end
    client:set({
        query = {
            authorization_key = 'locally_authorized',
            author = 'admin',
        }
    })
    local json = cjson.encode({
        connector = 'control.status@' .. mx_dev,
        request = 'get_info',
        params = {},
    })
    local res, _ = client:request(
        'POST',
        '/api/system/control',
        {data=json})
    return res
end

function m.mx_devices_synchronized(list)
    for k, v in pairs(list) do
        local info = get_mx_device_info(k)
        if not info or not info.synchronized then return end
    end
    return true
end

return m
