(function($){
    "use strict";
    var plugin_name = 'armada_comet';

    // SEE:
    // http://ajaxian.com/archives/dynamic-script-generation-and-memory-leaks
    function destroy(node) {
        // WebReflection IE leak attempt!
        if (node.attributes && node.clearAttributes)
            node.clearAttributes(); // Hedger suggestion
        while (node.lastChild)
            destroy(node.lastChild);
        if (node.parentNode)
            node.parentNode.removeChild(node);
    }

    var methods = {
        init: function(options) {
            var settings = {
                url: null,
                dispatcher: null,
                global_comet_function_name: null // KLUDGE
            };
            return this.each(function(){
                $(this).data(plugin_name, $.extend({}, settings, options));
            });
        },
        start: function() {
            var i, len;
            var o = this.data(plugin_name);
            o.div = $('<div style="display:none;"><iframe></iframe></div>');
            $("body").append(o.div);

            var dispatcher = o.dispatcher;
            var comet_iframe = $("iframe", o.div)[0];
            var comet_content = comet_iframe.contentDocument;
            window[o.global_comet_function_name] = function(e) {
                for (i = 0, len = e.length; i < len; i++) {
                    dispatcher(e[i][0], e[i][1], 'remote');
                }
                var scripts = comet_content.getElementsByTagName("script");
                for (i = 0, len = scripts.length; i < len - 1; i++)
                    destroy(scripts[i]);
            };
            comet_iframe.src = o.url;
        },
        stop: function() {
            var o = this.data(plugin_name);
            o.div.remove();
            delete o.div;
        }
    };

    $.fn[plugin_name] = function(method) {
        if (methods[method]) {
            return methods[method].apply(this,
                Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('jQuery.' + plugin_name + ': No such method ' + method);
        }
    };
}(jQuery));
